# $Id: proftpd.spec,v 1.4 2007/04/06 02:59:21 kamei Exp $

Summary:	ProFTPD -- Professional FTP Server.
Name:		proftpd
Version:	1.2.9
Release:	6ml
Copyright:	GPL
Group:		System Environment/Daemons
URL:		http://www.proftpd.org/
Source0:	ftp://ftp.proftpd.org/distrib/%{name}-%{version}.tar.bz2
Source1:	proftpd.xinetd
Patch0:		proftpd.miracleconf.patch
Patch1:         proftpd.libcap_ia64.patch
Patch2:		proftpd-1.2.9-enable_cidr.patch
Patch3:		proftpd-1.2.9-CVE-2004-1602.patch
Patch4:		proftpd-1.2.10-CAN-2005-2390.patch
Patch5:		proftpd-1.3.0-CVE-2005-4816.patch
Patch6:		proftpd-1.2.9-CVE-2006-5815.patch
Patch7:		proftpd-1.2.10-CVE-2006-6170.patch
Patch8:		proftpd-1.2.9-CVE-2006-6171.patch
Patch9:		proftpd-1.2.9-CVE-2006-5815-fix.patch
Prefix:		/usr
BuildRoot:	%{_builddir}/%{name}-%{version}-root
Requires:	pam >= 0.72
Provides:	ftpserver
Prereq:		fileutils, shadow-utils
Obsoletes:	proftpd-core

%description
ProFTPD is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration.  It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

There are two other packages you can use to setup for inetd or standalone
operation.

%package standalone
Summary:	ProFTPD -- Setup for standalone operation.
Group:		System Environment/Daemons
Requires:	proftpd chkconfig
Conflicts:	proftpd-xinetd

%description standalone
This package is neccesary to setup ProFTPD in standalone operation.

%package xinetd
Summary:	ProFTPD -- Setup for xinetd operation.
Group:		System Environment/Daemons
Requires:	proftpd
Conflicts:	proftpd-standalone

%description xinetd
This package is neccesary to setup ProFTPD to run from xinetd.

%prep
%setup -q
  CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=%{prefix} \
	--sysconfdir=/etc \
	--localstatedir=/var/run \
	--mandir=%{_mandir} \
	--with-modules=mod_ratio:mod_readme:mod_ldap
install -m644 %{SOURCE1} .
%patch0 -p1 -b .miracleconf
%ifarch ia64
%patch1 -p1 -b .libcap_ia64
%endif
%patch2 -p1 -b .enable_cidr

%patch3 -p1 -b .CVE-2004-1602
%patch4 -p0 -b .CVE-2005-2390
%patch5 -p0 -b .CVE-2005-4816
%patch6 -p1 -b .CVE-2006-5815
%patch7 -p0 -b .CVE-2006-6170
%patch8 -p0 -b .CVE-2006-6171
%patch9 -p1 -b .CVE-2006-5815-fix

%build
  make

%install
  rm -rf $RPM_BUILD_ROOT
#  make prefix=$RPM_BUILD_ROOT%{prefix} \
#	sysconfdir=$RPM_BUILD_ROOT/etc \
#	mandir=$RPM_BUILD_ROOT/%{_mandir} \
#	localstatedir=$RPM_BUILD_ROOT/var/run \
#	rundir=$RPM_BUILD_ROOT/var/run/proftpd \
#	INSTALL_USER=`id -un` INSTALL_GROUP=`id -gn` \
#    install DESTDIR=$RPM_BUILD_ROOT
  make install DESTDIR=$RPM_BUILD_ROOT
  mkdir -p $RPM_BUILD_ROOT/var/ftp
  mkdir -p $RPM_BUILD_ROOT/var/run/proftpd
  mkdir -p $RPM_BUILD_ROOT/etc/pam.d
  install -m 644 contrib/dist/rpm/ftp.pamd $RPM_BUILD_ROOT/etc/pam.d/ftp
  install -m 644 sample-configurations/basic.conf $RPM_BUILD_ROOT/etc/proftpd.conf
  mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
  sed -e '/FTPSHUT=/c\' \
	  -e 'FTPSHUT=%{prefix}/sbin/ftpshut' \
	contrib/dist/rpm/proftpd.init.d \
  > contrib/dist/rpm/proftpd.init.d.tmp
  mv --force contrib/dist/rpm/proftpd.init.d.tmp contrib/dist/rpm/proftpd.init.d
  install -m 755 contrib/dist/rpm/proftpd.init.d $RPM_BUILD_ROOT/etc/rc.d/init.d/proftpd
  mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d/
  install -m 644 contrib/dist/rpm/proftpd.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/proftpd
  mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d/
  install -m 644 proftpd.xinetd $RPM_BUILD_ROOT/etc/xinetd.d/proftpd
  # We don't want these dangling symlinks to make it into the RPM
  rm -f contrib/README.linux-privs contrib/README.mod_sql
  mkdir -p $RPM_BUILD_ROOT/%{_docdir}
  install -m 644 COPYING CREDITS ChangeLog NEWS $RPM_BUILD_ROOT/%{_docdir}

%pre
  if [ ! -f /etc/ftpusers ]; then
  	touch /etc/ftpusers
  	IFS=":"
	while { read username nu nu gid nu; }; do
		if [ $gid -le 100 -a "$username" != "ftp" ]; then
			echo $username
		fi
  	done < /etc/passwd > /etc/ftpusers
  fi

%preun
  if [ "$1" = 0 ]; then
    if [ -d /var/run/proftpd ]; then
		rm -rf /var/run/proftpd/*
    fi
  fi

%post
  /usr/sbin/usermod -d /var/ftp -s /bin/false ftp

%post standalone
  /sbin/chkconfig --add proftpd
  # Force the "ServerType" directive for this operation type.
  tmpfile=/tmp/proftpd-conf.$$
  sed	-e '/ServerType/c\' \
	-e 'ServerType	standalone' \
	/etc/proftpd.conf \
  > $tmpfile
  mv $tmpfile /etc/proftpd.conf

%preun standalone
  if [ "$1" = 0 ]; then
    /sbin/chkconfig --del proftpd
    /etc/rc.d/init.d/proftpd stop
  fi

%post xinetd
  # Force the "ServerType" directive for this operation type.
  tmpfile=/tmp/proftpd-conf.$$
  sed	-e '/ServerType/c\' \
	-e 'ServerType	inetd' \
	/etc/proftpd.conf \
  > $tmpfile
  mv $tmpfile /etc/proftpd.conf

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf %{_builddir}/%{name}-%{version}

%files
%defattr(-,root,root)
/usr/sbin/*
/usr/bin/*
/etc/logrotate.d/proftpd
%dir /var/run/proftpd
%dir /var/ftp
%config(noreplace) /etc/pam.d/ftp

%doc COPYING CREDITS ChangeLog NEWS
%doc README* doc/*
%doc contrib/README* contrib/xferstats.holger-preiss
%doc sample-configurations
%{_mandir}/*/*

%files standalone
%defattr(-,root,root)
/etc/rc.d/init.d/proftpd
%config(noreplace) /etc/proftpd.conf

%files xinetd
%defattr(-,root,root)
%config(noreplace) /etc/proftpd.conf
%config(noreplace) /etc/xinetd.d/proftpd

%changelog
* Fri Apr 06 2007 Ryoji Kamei <kamei@miraclelinux.com> 1.2.9-6ml
- fix CVE-2006-5815 patch (Patch9)

* Fri Mar 23 2007 Ryoji Kamei <kamei@miraclelinux.com> 1.2.9-5ml
- fixed many security issues
- CVE-2004-1602: Vulnerability by timing the server response (Patch3)
- CVE-2005-2390: Multiple format string vulnerabilities (Patch4)
- CVE-2005-4816: Buffer overflow in mod_radius (Patch5)
- CVE-2006-5815: Stack-based buffer overflow (Patch6)
- CVE-2006-6170: Buffer overflow in mod_tls (Patch7)
- CVE-2006-6171: Off-by-two buffer underflow, but disputed by the developer.
-                it still kept (Patch8)

* Thu Aug 26 2004 Shiro Yamada <shiro@miraclelinux.com> 1.2.9-4ml
- fixed a bug CAN-2004-0432 to enable CIDR based ACL control (patch2)

* Fri May  7 2004 Shiro Yamada <shiro@miraclelinux.com> 1.2.9-2ml
- brought up the code base to 1.2.9
- mod_cap (a.k.a mod_linuxprivs) is supported by default, so eliminate its entry in spec

* Wed May 14 2003 Yasuma Takeda <yasuma@miraclelinux.com>
- Support LDAP module

* Thu Dec 26 2002 Yuji Oishi <yoishi@miraclelinux.com>
- Delete Packager and Vendor tags
- Add proftpd.xinetd as Source1
- Add proftpd.miracleconf.patch as Patch0
- Add proftpd.libcap_ia64.patch as Patch1
- Add shadow_utils in Provides
- Change inetd to xinetd
  NOTE: do not change "ServerType: inetd" in proftpd.conf
- Change Obsoletes to Conflicts between proftpd-standalone and proftpd-xinetd
- Change ftp base directory from /home to /var
- Add proftpd.xinetd installation
- Delete parts of editing /etc/inetd.conf in "%post inetd" and "%postun inetd"
- add /etc/xinetd.d/proftpd to "%files xinetd"

* Sat Nov  2 2002 John Morrissey <jwm@horde.net>
- Don't let dangling contrib/README.* symlinks get into the built RPM
- logrotate for xferlog

* Wed Aug 14 2002 John Morrissey <jwm@horde.net>
- Added removal of build leftover directory in %clean.
  Submitted by: Christian Pelealu <kurisu@mweb.co.id>

* Wed Jul  3 2002 John Morrissey <jwm@horde.net> 1.2.6rc1-1
- 1.2.6rc1 release.

* Sun Jun  9 2002 John Morrissey <jwm@horde.net> 1.2.5-1
- 1.2.5 release.

* Fri May 10 2002 TJ Saunders <tj@castaglia.org>
- Added use of %defattr to allow build of RPMs by non-root users
  For details see http://bugs.proftpd.org/show_bug.cgi?id=1580

* Mon Mar 05 2001 Daniel Roesen <droesen@entire-systems.com>
- PAM >= 0.72 is now a requirement. Versions before are broken and
  Red Hat provides a PAM update for all RH 6.x releases. See:
  http://www.redhat.com/support/errata/RHSA-2000-120.html
  Thanks to O.Elliyasa <osman@Cable.EU.org> for the suggestion.
  For details see http://bugs.proftpd.org/show_bug.cgi?id=1048
- release: 1.2.1-2

* Wed Mar 01 2001 Daniel Roesen <droesen@entire-systems.com>
- Update to 1.2.1
- release: 1.2.1-1

* Wed Feb 27 2001 Daniel Roesen <droesen@entire-systems.com>
- added "Obsoletes: proftpd-core" to make migration to new RPMs easier.
  Thanks to Sbastien Prud'homme <prudhomme@easy-flying.com> for the hint.
- release: 1.2.0-3

* Wed Feb 26 2001 Daniel Roesen <droesen@entire-systems.com>
- cleaned up .spec formatting (cosmetics)
- fixed CFLAGS (fixes /etc/shadow support)
- included COPYING, CREDITS, ChangeLog and NEWS
- Renamed main package from "proftpd-core" to just "proftpd"
- release: 1.2.0-2

* Wed Feb 14 2001 Daniel Roesen <droesen@entire-systems.com>
- moved Changelog to bottom
- fixed %pre script /etc/ftpusers generator
- removed /ftp/ftpusers from package management. Deinstalling ProFTPD
  should _not_ result in removal of this file.

* Thu Oct 03 1999 O.Elliyasa <osman@Cable.EU.org>
- Multi package creation.
  Created core, standalone, inetd (&doc) package creations.
  Added startup script for init.d
  Need to make the "standalone & inetd" packages being created as "noarch"
- Added URL.
- Added prefix to make the package relocatable.

* Wed Sep 08 1999 O.Elliyasa <osman@Cable.EU.org>
- Corrected inetd.conf line addition/change logic.

* Sat Jul 24 1999 MacGyver <macgyver@tos.net>
- Initial import of spec.
